
__kernel void PaPaRaOpenCLUnfold8KernelCompressed(__global unsigned int * querySequence, 
				     __global          int * referenceSequence_a,
				     __global          int * arguments, 
				     __global          int * results,
				     __global          int * SC_matrix_line_first,
				     __local          int * Shared_Line,
				     __global unsigned int * SLSC_column_combined,
				     __global          int * referenceSequenceComp)
{


	unsigned int groupID = get_group_id(0);
	unsigned int localID = get_local_id(0);

	unsigned int globalID = get_global_id(0);
	results[globalID] = 0 ;
	
	unsigned int queTOTAL  = arguments[0];
	unsigned int refTOTAL  = arguments[1];

	if (groupID>=queTOTAL || localID >= refTOTAL) 
	{
		return;
	}
		
	unsigned int reflen    = arguments[2];
	unsigned int blosize   = arguments[3];
	unsigned int quelenMax = arguments[4];
	         int blocksize = arguments[5];
		 int blocksizediv4 = blocksize>>2;
           int blockiterations = arguments[6];
	int lastblock_refstart = arguments[7];
	
	/* ************************************ */

        

	int quelen = arguments[8+groupID];

	int band_width = reflen - quelen;
	
	int SCSL_column_offset = groupID * quelenMax * blosize + localID;
	int SC_line_first_offset = groupID * (quelenMax + blocksize) * blosize + localID;
	int querySequence_offset = quelenMax*groupID;

	int referenceSequenceComp_offset = quelenMax * blosize;

	int ref_i, que_i, sm, sl, su, sc, temp, sl_score_stay;

	int myD, myU, myL, nxtD, nxtU, nxtL, mySL, nxtSL, ref_first, ref_last;
  
   	int mySCORE=32000;

	int refVALUE;

	unsigned int refAUX;

	unsigned int nmatch;
	
	int last_sc_open = 0;

	int nxtD_bu;
	
	int internalindex=0;

	int queVALUE;

	unsigned int temp2;

	int COMPtemp, COMPtemp2;

	
/**/	

        	//////////////////////////////////////////////////////////////////////////////////////////// 
		// BLOCK 0 //
        	//////////////////////////////////////////////////////////////////////////////////////////// 
	
		// Block 0 - Row 0
		queVALUE = querySequence[querySequence_offset];
		
		ref_first = 0;
		nxtD = 0;
		nxtL = 32000;
		nxtSL = 32000;
		myD =0;
		myU =0;

		for(ref_i=ref_first;ref_i<quelenMax;ref_i++)
		{
	
			myL = nxtL;
			mySL = nxtSL;			

			temp = referenceSequence_a[localID + ref_i * blosize];
			
			refVALUE = temp>>1;
			refAUX = temp&1;

			nmatch = ( queVALUE & refVALUE ) == 0;

			sm = myD + nmatch;
			
			last_sc_open = myL + 2 * refAUX;
			sl_score_stay = mySL + refAUX;
			sm +=4;
			sm -=4*refAUX;
			
			sl = min( sl_score_stay, last_sc_open );

			nxtSL = sl;

			su = myU + 1;	

			sc = min( sm, min( su, sl ) );

			nxtL = sc;

			SC_matrix_line_first[SC_line_first_offset + ref_i * blosize] = sc;

		}
//		SL_matrix_column[SCSL_column_offset] = nxtSL;
//		SC_matrix_column[SCSL_column_offset] = nxtL;

		temp2 = nxtSL << 16;
		temp2 = temp2 | nxtL;
		SLSC_column_combined[SCSL_column_offset] = temp2;
		// End of Block 0 - Row 0
	

	// Block 0 - Rows 1 to quelen-1
	for(que_i=1;que_i<quelen-1;que_i++)    
    	{	
	
		queVALUE = querySequence[que_i+querySequence_offset];
		
		ref_first = que_i;
	
		nxtD = SC_matrix_line_first[SC_line_first_offset + (que_i-1)*blosize];

		nxtL = 32000;
		nxtSL = 32000;

		for(ref_i=ref_first;ref_i<quelenMax;ref_i++)
		{
	
			
			myD = nxtD;
			myU = SC_matrix_line_first[SC_line_first_offset + ref_i * blosize];
			myL = nxtL;
			mySL = nxtSL;
				
			temp = referenceSequence_a[localID + ref_i * blosize];
			
			refVALUE = temp>>1;
			refAUX = temp&1;

			nmatch = ( queVALUE & refVALUE ) == 0;

			sm = myD + nmatch;

			last_sc_open = myL + 2 * refAUX;
			sl_score_stay = mySL + refAUX;
			sm +=4;
			sm -=4*refAUX;

			sl = min( sl_score_stay, last_sc_open );

			nxtSL = sl;

			su = myU + 1;	

			sc = min( sm, min( su, sl ) );

			nxtL = sc;

			SC_matrix_line_first[SC_line_first_offset + ref_i * blosize] = sc;

			nxtD = myU;
		}
//		SL_matrix_column[SCSL_column_offset + que_i * blosize] = nxtSL;
//		SC_matrix_column[SCSL_column_offset + que_i * blosize] = nxtL;
		temp2 = nxtSL << 16;
		temp2 = temp2 | nxtL;
		SLSC_column_combined[SCSL_column_offset  + que_i * blosize] = temp2;
		

	}

		// Block 0 - Row quelen-1
		queVALUE = querySequence[que_i+querySequence_offset];
		
		ref_first = que_i;
	
		nxtD = SC_matrix_line_first[SC_line_first_offset + (que_i-1)*blosize];

		nxtL = 32000;
		nxtSL = 32000;

		for(ref_i=ref_first;ref_i<quelenMax;ref_i++)
		{
	
			myD = nxtD;
			myU = SC_matrix_line_first[SC_line_first_offset + ref_i * blosize];
			myL = nxtL;
			mySL = nxtSL;

			temp = referenceSequence_a[localID + ref_i * blosize];
			
			refVALUE = temp>>1;
			refAUX = temp&1;

			nmatch = ( queVALUE & refVALUE ) == 0;

			sm = myD + nmatch;

			last_sc_open = myL + 2 * refAUX;
			sl_score_stay = mySL + refAUX;
			sm +=4;
			sm -=4*refAUX;

			sl = min( sl_score_stay, last_sc_open );

			nxtSL = sl;

			su = myU + 1;	

			sc = min( sm, min( su, sl ) );

			nxtL = sc;

			SC_matrix_line_first[SC_line_first_offset + ref_i * blosize] = sc;

			nxtD = myU;

			mySCORE = min(mySCORE,sc);	
		}
//		SL_matrix_column[SCSL_column_offset + que_i * blosize] = nxtSL;
//		SC_matrix_column[SCSL_column_offset + que_i * blosize] = nxtL;
	

		temp2 = nxtSL << 16;
		temp2 = temp2 | nxtL;
		SLSC_column_combined[SCSL_column_offset  + que_i * blosize] = temp2;
		// End Block 0 - Row quelen-1



	///////////////////////////////////////////////////////////////////////////////////////////// 
						// BLOCKs 1 to LAST-1 //
        ///////////////////////////////////////////////////////////////////////////////////////////// 
 	
	unsigned int blocki=0;

	
	for(blocki=0;blocki<blockiterations;blocki++) // 3. blockiterations
	{
		
	
			// Row 0
			que_i=0;

			queVALUE = querySequence[querySequence_offset];
			
			ref_first = 0;	
		
			nxtD = 0;

			temp2 = SLSC_column_combined[SCSL_column_offset];
			nxtSL = temp2 >> 16;
			nxtL = temp2 & 65535;			
			
			//nxtL = SC_matrix_column[SCSL_column_offset];
			//nxtSL = SL_matrix_column[SCSL_column_offset];
			
			nxtD_bu = nxtL;
			internalindex=0;
			myD = 0;
			myU = 0;

			//for(ref_i=quelenMax + blocki*blocksize;ref_i<quelenMax + blocki*blocksize + blocksize;ref_i++)
			//{
				
				//ref_i = quelenMax + blocki*blocksize;	
				myL = nxtL;
				mySL = nxtSL;
		
				//temp = referenceSequence_a[localID + ref_i*blosize];

				COMPtemp = referenceSequenceComp[localID + (blocki * blocksizediv4) * blosize];
				
				temp = COMPtemp>>15;

				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;

				sm = myD + nmatch;
			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
			
				Shared_Line [localID + internalindex*blosize]=sc;

				internalindex++;

				//ref_i++;

				myL = nxtL;
				mySL = nxtSL;
		
				//temp = referenceSequence_a[localID + ref_i*blosize];

				temp = (COMPtemp>>10)&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;

				sm = myD + nmatch;
			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
			
				Shared_Line [localID + internalindex*blosize]=sc;

				internalindex++;

				//ref_i++;

				myL = nxtL;
				mySL = nxtSL;
		
				//temp = referenceSequence_a[localID + ref_i*blosize];

				temp = (COMPtemp>>5)&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;

				sm = myD + nmatch;
			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
			
				Shared_Line [localID + internalindex*blosize]=sc;

				internalindex++;

				//ref_i++;

				myL = nxtL;
				mySL = nxtSL;
		
				//temp = referenceSequence_a[localID + ref_i*blosize];
			
				temp = COMPtemp&31;

				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;

				sm = myD + nmatch;
			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
			
				Shared_Line [localID + internalindex*blosize]=sc;

				internalindex++;

				//ref_i++;

				myL = nxtL;
				mySL = nxtSL;
		
				//temp = referenceSequence_a[localID + ref_i*blosize];

				COMPtemp = referenceSequenceComp[localID + (blocki * blocksizediv4 + 1) * blosize];
				
				temp = COMPtemp>>15;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;

				sm = myD + nmatch;
			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
			
				Shared_Line [localID + internalindex*blosize]=sc;

				internalindex++;

				//ref_i++;

				myL = nxtL;
				mySL = nxtSL;
		
				//temp = referenceSequence_a[localID + ref_i*blosize];

				temp = (COMPtemp>>10)&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;

				sm = myD + nmatch;
			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
			
				Shared_Line [localID + internalindex*blosize]=sc;

				internalindex++;

				//ref_i++;

				myL = nxtL;
				mySL = nxtSL;
		
				//temp = referenceSequence_a[localID + ref_i*blosize];

				temp = (COMPtemp>>5)&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;

				sm = myD + nmatch;
			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
			
				Shared_Line [localID + internalindex*blosize]=sc;

				internalindex++;

				//ref_i++;

				myL = nxtL;
				mySL = nxtSL;
		
				//temp = referenceSequence_a[localID + ref_i*blosize];

				temp = COMPtemp&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;

				sm = myD + nmatch;
			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
			
				Shared_Line [localID + internalindex*blosize]=sc;

				//internalindex++;	
			//}
//			SL_matrix_column[SCSL_column_offset] = nxtSL;
//			SC_matrix_column[SCSL_column_offset] = nxtL;

			temp2 = nxtSL << 16;
			temp2 = temp2 | nxtL;
		
			SLSC_column_combined[SCSL_column_offset] = temp2;
	

		// ROWs 1 to QUELEN-1
		for(que_i=1;que_i<quelen-1;que_i++)    
	    	{	
	
			queVALUE = querySequence[que_i+querySequence_offset];
			
			ref_first = que_i;	
		
			nxtD = nxtD_bu;
			
			temp2 = SLSC_column_combined[SCSL_column_offset + que_i * blosize];
			nxtSL = temp2 >> 16;
			nxtL = temp2 & 65535;			
		

//			nxtL = SC_matrix_column[SCSL_column_offset + que_i * blosize];
//			nxtSL = SL_matrix_column[SCSL_column_offset + que_i * blosize];
			nxtD_bu = nxtL;
			internalindex=0;

			//for(ref_i=quelenMax + blocki*blocksize;ref_i<quelenMax + blocki*blocksize + blocksize;ref_i++)
			//{	
	
				//ref_i=quelenMax + blocki*blocksize;
				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];				
				
				myL = nxtL;
				mySL = nxtSL;

				//temp = referenceSequence_a[localID + ref_i*blosize];

				COMPtemp = referenceSequenceComp[localID + (blocki * blocksizediv4) * blosize];
				
				//COMPtemp2=COMPtemp;
				temp = COMPtemp>>15;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;
				

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				internalindex++;

				//ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];				
				
				myL = nxtL;
				mySL = nxtSL;

				//temp = referenceSequence_a[localID + ref_i*blosize];

				temp = (COMPtemp>>10)&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;
				

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				internalindex++;

				//ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];				
				
				myL = nxtL;
				mySL = nxtSL;

				//temp = referenceSequence_a[localID + ref_i*blosize];

				temp = (COMPtemp>>5)&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;
				

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				internalindex++;

				//ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];				
				
				myL = nxtL;
				mySL = nxtSL;

				//temp = referenceSequence_a[localID + ref_i*blosize];

				temp = COMPtemp&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;
				

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				internalindex++;

				//ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];				
				
				myL = nxtL;
				mySL = nxtSL;

				//temp = referenceSequence_a[localID + ref_i*blosize];

				COMPtemp2 = referenceSequenceComp[localID + (blocki * blocksizediv4 + 1) * blosize];			
				
				
				temp = COMPtemp2>>15;

				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;
				

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				internalindex++;

				//ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];				
				
				myL = nxtL;
				mySL = nxtSL;

				//temp = referenceSequence_a[localID + ref_i*blosize];

				temp = (COMPtemp2>>10)&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;
				

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				internalindex++;

				//ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];				
				
				myL = nxtL;
				mySL = nxtSL;

				//temp = referenceSequence_a[localID + ref_i*blosize];
			
				temp = (COMPtemp2>>5)&31;
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;
				

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				internalindex++;

				//ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];				
				
				myL = nxtL;
				mySL = nxtSL;

				//temp = referenceSequence_a[localID + ref_i*blosize];
			
				temp = COMPtemp2&31;

				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			
				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;
				

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

			//	internalindex++;
			//}
			
//			SL_matrix_column[SCSL_column_offset + que_i * blosize] = nxtSL;
//			SC_matrix_column[SCSL_column_offset + que_i * blosize] = nxtL;
			
			temp2 = nxtSL << 16;
			temp2 = temp2 | nxtL;
			SLSC_column_combined[SCSL_column_offset  + que_i * blosize ] = temp2;
	
	
		}				
			

			// ROW quelen - 1
			queVALUE = querySequence[que_i+querySequence_offset];			
			ref_first = que_i;		
			nxtD = nxtD_bu;
			temp2 = SLSC_column_combined[SCSL_column_offset + que_i * blosize];
			nxtSL = temp2 >> 16;
			nxtL = temp2 & 65535;
//			nxtL = SC_matrix_column[SCSL_column_offset + que_i * blosize];
//			nxtSL = SL_matrix_column[SCSL_column_offset + que_i * blosize];
			nxtD_bu = nxtL;
			internalindex=0;

			//for(ref_i=quelenMax + blocki*blocksize;ref_i<quelenMax + blocki*blocksize + blocksize;ref_i++)
			//{
				
				ref_i=quelenMax + blocki*blocksize;
				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];
				myL = nxtL;
				mySL = nxtSL;

				temp = referenceSequence_a[localID + ref_i*blosize];
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			

				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				mySCORE = min(mySCORE,sc);	
		
				internalindex++;

				ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];
				myL = nxtL;
				mySL = nxtSL;

				temp = referenceSequence_a[localID + ref_i*blosize];
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			

				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				mySCORE = min(mySCORE,sc);	
		
				internalindex++;

				ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];
				myL = nxtL;
				mySL = nxtSL;

				temp = referenceSequence_a[localID + ref_i*blosize];
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			

				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				mySCORE = min(mySCORE,sc);	
		
				internalindex++;

				ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];
				myL = nxtL;
				mySL = nxtSL;

				temp = referenceSequence_a[localID + ref_i*blosize];
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			

				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				mySCORE = min(mySCORE,sc);	
		
				internalindex++;

				ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];
				myL = nxtL;
				mySL = nxtSL;

				temp = referenceSequence_a[localID + ref_i*blosize];
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			

				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				mySCORE = min(mySCORE,sc);	
		
				internalindex++;

				ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];
				myL = nxtL;
				mySL = nxtSL;

				temp = referenceSequence_a[localID + ref_i*blosize];
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			

				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				mySCORE = min(mySCORE,sc);	
		
				internalindex++;

				ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];
				myL = nxtL;
				mySL = nxtSL;

				temp = referenceSequence_a[localID + ref_i*blosize];
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			

				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				mySCORE = min(mySCORE,sc);	
		
				internalindex++;

				ref_i++;

				myD = nxtD;
				myU = Shared_Line [localID + internalindex*blosize];
				myL = nxtL;
				mySL = nxtSL;

				temp = referenceSequence_a[localID + ref_i*blosize];
			
				refVALUE = temp>>1;
				refAUX = temp&1;

				nmatch = ( queVALUE & refVALUE ) == 0;


				sm = myD + nmatch;

			

				last_sc_open = myL + 2 * refAUX;
				sl_score_stay = mySL + refAUX;
				sm +=4;
				sm -=4*refAUX;

				sl = min( sl_score_stay, last_sc_open );

				nxtSL = sl;

				su = myU + 1;	

				sc = min( sm, min( su, sl ) );

				nxtL = sc;
		
				Shared_Line [localID + internalindex*blosize] = sc;
				nxtD = myU;

				mySCORE = min(mySCORE,sc);	
		
				internalindex++;	
			//}
//			SL_matrix_column[SCSL_column_offset + que_i * blosize] = nxtSL;
//			SC_matrix_column[SCSL_column_offset + que_i * blosize] = nxtL;
//			SLSC_column_combined[SCSL_column_offset + que_i*blosize] = nxtL;
			temp2 = nxtSL << 16;
			temp2 = temp2 | nxtL;
			SLSC_column_combined[SCSL_column_offset  + que_i * blosize ] = temp2;
	
			// END ROW quelen-1


	}





	///////////////////////////////////////////////////////////////////////////////////////////// 
						// LAST BLOCK //
        ///////////////////////////////////////////////////////////////////////////////////////////// 


	//nxtD_bu = 0;

		// ROW 0
		//que_i=0;
		queVALUE = querySequence[querySequence_offset];
		
		ref_last = band_width + 1;
		
		nxtD = 0;

		temp2 = SLSC_column_combined[SCSL_column_offset];
		nxtSL = temp2 >> 16;
		nxtL = temp2 & 65535;			

//		nxtL = SC_matrix_column[SCSL_column_offset];
//		nxtSL = SL_matrix_column[SCSL_column_offset];
		nxtD_bu = nxtL;

		internalindex=0;
		for(ref_i=lastblock_refstart;ref_i<ref_last-1;ref_i++)
		{
	
			myD = nxtD;
			myU = 0;//que_i==0?0:SC_matrix_line_first[SC_line_first_offset + internalindex*blosize];
			myU = myU;//ref_i==ref_last-1?32000:myU;
			myL = nxtL;
			mySL = nxtSL;

			temp = referenceSequence_a[localID + ref_i*blosize];
			
			refVALUE = temp>>1;
			refAUX = temp&1;


			nmatch = ( queVALUE & refVALUE ) == 0 ;

			sm = myD + nmatch;

			last_sc_open = myL + 2 * refAUX;
			sl_score_stay = mySL + refAUX;
			sm +=4;
			sm -=4*refAUX;

			sl = min( sl_score_stay, last_sc_open );

			nxtSL = sl;

			su = myU + 1;	

			sc = min( sm, min( su, sl ) );

			nxtL = sc;
		
			SC_matrix_line_first[SC_line_first_offset + internalindex*blosize] = sc;

			nxtD = myU;

			internalindex++;					
		}

			// Last Column
			//myD = nxtD;
			//myU = 0;//que_i==0?0:SC_matrix_line_first[SC_line_first_offset + internalindex*blosize];
			//myU = 32000;//ref_i==ref_last-1?32000:myU;
			//myL = nxtL;
			//mySL = nxtSL;

			temp = referenceSequence_a[localID + ref_i*blosize];
			
			refVALUE = temp>>1;
			refAUX = temp&1;


			nmatch = ( queVALUE & refVALUE ) == 0 ;

			sm = nxtD + nmatch;


			last_sc_open = nxtL + 2 * refAUX;
			sl_score_stay = nxtSL + refAUX;
			sm +=4;
			sm -=4*refAUX;

			sl = min( sl_score_stay, last_sc_open );

			//nxtSL = sl;

			su = 32001;	

			sc = min( sm, min( su, sl ) );

			//nxtL = sc;
		
			SC_matrix_line_first[SC_line_first_offset + internalindex*blosize] = sc;

			//nxtD = myU;

			//internalindex++;


	///////////////////////////////////////////////////////////////////////////////////////////////////////////////

	// ROW 1 to QUELEN -1
	for(que_i=1;que_i<quelen-1;que_i++)    
    	{	
	
		queVALUE = querySequence[que_i+querySequence_offset];
		
		ref_last = que_i + band_width + 1;
		
		nxtD = nxtD_bu;

		temp2 = SLSC_column_combined[SCSL_column_offset + que_i * blosize];
		nxtSL = temp2 >> 16;
		nxtL = temp2 & 65535;			

//		nxtL = SC_matrix_column[SCSL_column_offset + que_i * blosize];
//		nxtSL = SL_matrix_column[SCSL_column_offset + que_i * blosize];
		nxtD_bu = nxtL;

		internalindex=0;
		for(ref_i=lastblock_refstart;ref_i<ref_last-1;ref_i++)
		{
	
			myD = nxtD;
			myU = SC_matrix_line_first[SC_line_first_offset + internalindex*blosize];
			//myU = myU;
			myL = nxtL;
			mySL = nxtSL;

			temp = referenceSequence_a[localID + ref_i*blosize];
			
			refVALUE = temp>>1;
			refAUX = temp&1;


			nmatch = ( queVALUE & refVALUE ) == 0 ;

			sm = myD + nmatch;


			last_sc_open = myL + 2 * refAUX;
			sl_score_stay = mySL + refAUX;
			sm +=4;
			sm -=4*refAUX;

			sl = min( sl_score_stay, last_sc_open );

			nxtSL = sl;

			su = myU + 1;	

			sc = min( sm, min( su, sl ) );

			nxtL = sc;
		
			SC_matrix_line_first[SC_line_first_offset + internalindex*blosize] = sc;

			nxtD = myU;

			internalindex++;					
		}

			myD = nxtD;
			myU = SC_matrix_line_first[SC_line_first_offset + internalindex*blosize];
			myU = 32000;//ref_i==ref_last-1?32000:myU;
			myL = nxtL;
			mySL = nxtSL;

			temp = referenceSequence_a[localID + ref_i*blosize];
			
			refVALUE = temp>>1;
			refAUX = temp&1;


			nmatch = ( queVALUE & refVALUE ) == 0 ;

			sm = myD + nmatch;


			last_sc_open = myL + 2 * refAUX;
			sl_score_stay = mySL + refAUX;
			sm +=4;
			sm -=4*refAUX;

			sl = min( sl_score_stay, last_sc_open );

			nxtSL = sl;

			su = myU + 1;	

			sc = min( sm, min( su, sl ) );

			nxtL = sc;
		
			SC_matrix_line_first[SC_line_first_offset + internalindex*blosize] = sc;

			nxtD = myU;

			internalindex++;
	}


		// last row
		queVALUE = querySequence[que_i+querySequence_offset];
		
		ref_last = que_i + band_width + 1;
		
		nxtD = nxtD_bu;

		temp2 = SLSC_column_combined[SCSL_column_offset + que_i * blosize];
		nxtSL = temp2 >> 16;
		nxtL = temp2 & 65535;			

//		nxtL = SC_matrix_column[SCSL_column_offset + que_i * blosize];
//		nxtSL = SL_matrix_column[SCSL_column_offset + que_i * blosize];
		nxtD_bu = nxtL;

		internalindex=0;
		for(ref_i=lastblock_refstart;ref_i<ref_last-1;ref_i++)
		{
	
			myD = nxtD;
			myU = SC_matrix_line_first[SC_line_first_offset + internalindex*blosize];
			myU = myU;
			myL = nxtL;
			mySL = nxtSL;

			temp = referenceSequence_a[localID + ref_i*blosize];
			
			refVALUE = temp>>1;
			refAUX = temp&1;


			nmatch = ( queVALUE & refVALUE ) == 0 ;

			sm = myD + nmatch;


			last_sc_open = myL + 2 * refAUX;
			sl_score_stay = mySL + refAUX;
			sm +=4;
			sm -=4*refAUX;

			sl = min( sl_score_stay, last_sc_open );

			nxtSL = sl;

			su = myU + 1;	

			sc = min( sm, min( su, sl ) );

			nxtL = sc;
		
			SC_matrix_line_first[SC_line_first_offset + internalindex*blosize] = sc;

			nxtD = myU;

			//if(que_i==quelen-1)
			//{
				mySCORE = min(mySCORE,sc);	
			//}
			internalindex++;					
		}

			//myD = nxtD;
			//myU = SC_matrix_line_first[SC_line_first_offset + internalindex*blosize];
			//myU = 32000;//ref_i==ref_last-1?32000:myU;
			//myL = nxtL;
			//mySL = nxtSL;

			temp = referenceSequence_a[localID + ref_i*blosize];
			
			refVALUE = temp>>1;
			refAUX = temp&1;


			nmatch = ( queVALUE & refVALUE ) == 0 ;

			sm = nxtD + nmatch;


			last_sc_open = nxtL + 2 * refAUX;
			sl_score_stay = nxtSL + refAUX;
			sm +=4;
			sm -=4*refAUX;

			sl = min( sl_score_stay, last_sc_open );

			//nxtSL = sl;

			su = 32001;	

			sc = min( sm, min( su, sl ) );

			//nxtL = sc;
		
			SC_matrix_line_first[SC_line_first_offset + internalindex*blosize] = sc;

			//nxtD = myU;

			//if(que_i==quelen-1)
			//{
			mySCORE = min(mySCORE,sc);	
			//}
			//internalindex++;	
		/////////////////////////////////////////////////////////////////////////////////////////




	results[globalID] = mySCORE;

		
}









