/*
 * Copyright (C) 2011 Simon A. Berger
 *
 *  This program is free software; you may redistribute it and/or modify its
 *  under the terms of the GNU General Public License as published by the Free
 *  Software Foundation; either version 2 of the License, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 */


#ifndef __papara_gpu_h
#define __papara_gpu_h

#include <cstdlib>
#include <vector>
#include <map>
#include <cstddef>
#include <stdint.h>

class papara_gpu_driver {

public:
	virtual void run() = 0;
	virtual const std::map<std::pair<size_t, size_t>, int> &get_res_map() = 0;
	virtual ~papara_gpu_driver() {}
};


class papara_gpu_driver2 {

public:
	virtual std::vector<int> run(const std::vector< std::vector<int> *> &pvecs, const std::vector< std::vector<unsigned int> *> &aux, const std::vector<size_t> &ref_ids ) = 0;
//	virtual const std::map<std::pair<size_t, size_t>, int> &get_res_map() = 0;
	virtual ~papara_gpu_driver2() {}
};



papara_gpu_driver *new_papara_gpu_driver( const std::vector<std::vector <int> > &pvecs, const std::vector<std::vector <unsigned int> > &aux, const std::vector<std::vector <uint8_t> > &qs, size_t start, size_t end );
papara_gpu_driver2 *new_papara_gpu_driver2( size_t ref_len, const std::vector<std::vector <uint8_t> > &qs );

bool papara_gpu_driver_available();

#endif
