
#ifndef __utils_papara_h
#define __utils_papara_h

#include <CL/opencl.h>

void ocl_check_ex(cl_int iSample, cl_int iReference, const char* cFile, const int iLine);

#define ocl_check(a,b) ocl_check_ex(a,b,__FILE__,__LINE__)


unsigned int fixthis (size_t ref_len, size_t sharedKBytes, size_t memBanks);
unsigned int * refInpAll_Reorg (size_t ref_len, size_t refAll_num, std::vector<std::vector <int> > inpRefAll, int alignBlock_len);
const size_t getCompactRefSize (const size_t compactRefMode, const size_t reflen, const size_t alignBlockSize);
const size_t getCompactSize (const size_t compactRefMode, const size_t reflen, const size_t alignBlockSize);
unsigned int * getCompactReference (const size_t compactRefMode, const size_t reflen, std::vector<int> &a, std::vector<unsigned int> &a_aux,const size_t compactRefSize);
unsigned int * getCompactQuery (const size_t compactQueryMode, const size_t quelen, std::vector<unsigned char> &a,const size_t compactQuerySize);
void showBitsMSB(unsigned int input);



void putSequenceRef_Inter_Dual(unsigned int seqIndex, std::vector<int> &a, std::vector<unsigned int> &a_aux, unsigned int constSeqLen, int * sequencesAll_a, unsigned int * sequencesAll_a_aux, unsigned int interSeqBloLen);




//* Of *//
unsigned int get_sGloIndex (unsigned int sharedMemSize, unsigned int PadBloLen);
unsigned int get_next32mult (unsigned int input);
unsigned int get_constSequenceLength (unsigned int sequenceLength, unsigned int memoryBlockSize, unsigned int compressEffort);
float get_shareMemLineSize (unsigned int constSequenceLength);
void putSequenceRef(unsigned int seqIndex, std::vector<int> &a, std::vector<unsigned int> &a_aux, unsigned int constSeqLen, unsigned int * sequencesAll);
void putSequenceRef_Inter(unsigned int seqIndex, std::vector<int> &a, std::vector<unsigned int> &a_aux, unsigned int constSeqLen, unsigned int * sequencesAll, unsigned int interSeqBloLen);
void putSequenceQue(unsigned int seqIndex, const std::vector<unsigned char> &a, unsigned int constSeqLen, unsigned int * sequencesAll);
//float get_gMemTotal(unsigned int num_of_queries, unsigned int num_of_references, unsigned int constQueryLength, unsigned int constReferenceLength);
void putSequenceRef_InterInt(unsigned int seqIndex, std::vector<int> &a, std::vector<unsigned int> &a_aux, unsigned int constSeqLen, int * sequencesAll, unsigned int interSeqBloLen);
void putSequenceRef_InterIntComp (unsigned int seqIndex, const std::vector<int> &a, const std::vector<unsigned int> &a_aux, unsigned int constSeqLen, int start_pos, int last_pos, int * CompsequencesAll, unsigned int interSeqBloLen);

void putSequenceRef_InterIntCompRev (unsigned int seqIndex, const std::vector<int> &a, const std::vector<unsigned int> &a_aux, unsigned int constSeqLen, int start_pos, int last_pos, int * CompsequencesAll, unsigned int interSeqBloLen);

void putSequenceRef_CombinedS1(unsigned int seqIndex, const std::vector<int> &a, const std::vector<unsigned int> &a_aux, unsigned int constSeqLen, int * sequencesAll, unsigned int interSeqBloLen);

void putSequenceRef_CombinedS2(unsigned int seqIndex, const std::vector<int> &a, const std::vector<unsigned int> &a_aux, unsigned int constSeqLen, int * sequencesAll, unsigned int interSeqBloLen,  int quelenmax,  int blockiterations,  int blocksizecompressed,  int startpos);

void putSequenceRef_InterIntCompCombined (unsigned int seqIndex, const std::vector<int> &a, const std::vector<unsigned int> &a_aux, unsigned int constSeqLen, int start_pos, int last_pos, int * CompsequencesAll, unsigned int interSeqBloLen, unsigned int startpos);


#endif
